﻿Imports System.Runtime.InteropServices

Public Class Form1

    '***************************** Einbinden der Funktionen *****************************************
    <DllImport("TRIXI.dll")> _
    Private Shared Function Connect(ByVal IP As String, ByVal Port As Integer) As Boolean
    End Function

    <DllImport("TRIXI.dll")> _
    Private Shared Function Disconnect() As Boolean
    End Function

    <DllImport("TRIXI.dll")> _
    Private Shared Function IsOnline() As Boolean
    End Function

    <DllImport("TRIXI.dll")> _
    Private Shared Function WriteString(ByVal VariableID As Integer, ByVal Value As String) As Integer
    End Function

    <DllImport("TRIXI.dll")> _
    Private Shared Function WriteInteger(ByVal VariableID As Integer, ByVal Value As Integer) As Integer
    End Function

    <DllImport("TRIXI.dll")> _
    Private Shared Function WriteFloat(ByVal VariableID As Integer, ByVal Value As Double) As Integer
    End Function

    <DllImport("TRIXI.dll")> _
    Private Shared Function WriteBoolean(ByVal VariableID As Integer, ByVal Value As Boolean) As Integer
    End Function

    <DllImport("TRIXI.dll")> _
    Private Shared Function ReadString(ByVal VariableID As Integer) As String
    End Function

    <DllImport("TRIXI.dll")> _
    Private Shared Function ReadInteger(ByVal VariableID As Integer) As Integer
    End Function

    <DllImport("TRIXI.dll")> _
    Private Shared Function ReadFloat(ByVal VariableID As Integer) As Double
    End Function

    <DllImport("TRIXI.dll")> _
    Private Shared Function ReadBoolean(ByVal VariableID As Integer) As Boolean
    End Function

    <DllImport("TRIXI.dll")> _
    Private Shared Function RunScript(ByVal ScriptID As Integer) As Integer
    End Function

    <DllImport("TRIXI.dll")> _
    Private Shared Function GetScriptIDByName(ByVal Script As String, ByVal ParentID As Integer) As Integer
    End Function

    <DllImport("TRIXI.dll")> _
    Private Shared Function GetVariableIDByName(ByVal Variable As String, ByVal ParentID As Integer) As Integer
    End Function

    <DllImport("TRIXI.dll")> _
    Private Shared Sub WriteDebugFile(ByVal FilePath As String, ByVal MsgSink As Boolean)
    End Sub

    <DllImport("TRIXI.dll")> _
    Private Shared Function VariableExists(ByVal VariableID As Integer) As Boolean
    End Function

    <DllImport("TRIXI.dll")> _
    Private Shared Function ScriptExists(ByVal ScriptID As Integer) As Boolean
    End Function


    '------------------------- Call Back -----------------------------------------------

    <DllImport("TRIXI.dll", CallingConvention:=CallingConvention.StdCall)> _
    Private Shared Sub SetSimpleVarCallback(ByVal svc As SimpleVarCallback)
    End Sub

    <DllImport("TRIXI.dll", CallingConvention:=CallingConvention.StdCall)> _
    Private Shared Sub SetVarChangeCallback(ByVal vc As VarCallback)
    End Sub

    <DllImport("TRIXI.dll", CallingConvention:=CallingConvention.StdCall)> _
    Private Shared Sub SetVarUpdateCallback(ByVal vc As VarCallback)
    End Sub

    'Delegate
    Public Delegate Sub SimpleVarCallback(ByVal ID As Integer)
    Public Delegate Sub VarCallback(ByVal ID As Integer, ByVal Time As Double, ByVal Value As String)

    Dim mySimpleVarCallback As SimpleVarCallback
    Dim myVarChangeCallback As VarCallback
    Dim myVarUpdateCallback As VarCallback

    '***************************** Einbinden der Funktionen ENDE *****************************************

    Private Sub btConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btConnect.Click
        If Connect(tbIP.Text, 3773) Then
            MessageBox.Show("Connected")
        Else
            MessageBox.Show("Connection failed")
        End If
    End Sub

    Private Sub tbDisconnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbDisconnect.Click
        Disconnect()
    End Sub

    Private Sub btLogFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btLogFile.Click
        WriteDebugFile("TRIXI.log", True)
    End Sub

    Private Sub btSendString_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btSendString.Click
        WriteString(tbWSID.Text, tbWriteString.Text)
    End Sub

    Private Sub btReceiveString_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btReceiveString.Click
        tbWriteString.Text = ReadString(tbWSID.Text)
    End Sub

    Private Sub btSendInteger_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btSendInteger.Click
        Dim SendInteger As Integer
        SendInteger = Integer.Parse(tbWriteInteger.Text)
        WriteInteger(tbWIID.Text, SendInteger)
    End Sub

    Private Sub btReceiveInteger_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btReceiveInteger.Click
        tbWriteInteger.Text = ReadInteger(tbWIID.Text)
    End Sub

    Private Sub btIsOnline_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btIsOnline.Click
        If IsOnline() Then
            MessageBox.Show("Is Online!!")
        Else
            MessageBox.Show("Is Offline!!")
        End If
    End Sub

    Private Sub btSendFloat_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btSendFloat.Click
        Dim SendFloat As Double
        SendFloat = Double.Parse(tbWriteFloat.Text)
        WriteFloat(tbWFID.Text, SendFloat)
    End Sub

    Private Sub btReceiveFloat_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btReceiveFloat.Click
        tbWriteFloat.Text = ReadFloat(tbWFID.Text)
    End Sub

    Private Sub btSendBoolean_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btSendBoolean.Click
        WriteBoolean(tbWBID.Text, cbBoolean.Checked)
    End Sub

    Private Sub tbReceiveBoolean_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbReceiveBoolean.Click
        cbBoolean.Checked = ReadBoolean(tbWBID.Text)
    End Sub

    Private Sub btRunScript_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btRunScript.Click
        RunScript(tbRSID.Text)
    End Sub

    Private Sub btGetScriptID_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btGetScriptID.Click
        Try
            tbScriptID.Text = GetScriptIDByName(tbScriptName.Text, tbParentID.Text)
        Catch ex As SEHException
            MessageBox.Show("Scriptname oder ParentID falsch", ex.Message)
        End Try
    End Sub

    Private Sub btGetVarID_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btGetVarID.Click
        Try
            tbVarID.Text = GetVariableIDByName(tbVarName.Text, tbParentIDVar.Text)
        Catch ex2 As SEHException
            MessageBox.Show("Variablenname oder ParentID falsch", ex2.Message)
        End Try
    End Sub

    Private Sub btVarEx_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btVarEx.Click
        cbVarEx.Checked = VariableExists(tbVarExID.Text)
    End Sub

    Private Sub btScriptEx_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btScriptEx.Click
        cbScriptEx.Checked = ScriptExists(tbScriptExID.Text)
    End Sub

    Private Sub btCallBack_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btCallBack.Click
        'Delegates anlegen
        mySimpleVarCallback = New SimpleVarCallback(AddressOf SimpleVarCallbackImpl)
        myVarChangeCallback = New VarCallback(AddressOf VarChangeCallbackImpl)
        myVarUpdateCallback = New VarCallback(AddressOf VarUpdateCallbackImpl)

        'Zuweisen
        SetSimpleVarCallback(mySimpleVarCallback)
        SetVarChangeCallback(myVarChangeCallback)
        SetVarUpdateCallback(myVarUpdateCallback)
    End Sub

    Public Sub SimpleVarCallbackImpl(ByVal ID As Integer)
        tbCallBack.Text = tbCallBack.Text & "SimpleVarCallback: " & ID & vbCrLf
    End Sub

    Public Sub VarChangeCallbackImpl(ByVal ID As Integer, ByVal Time As Double, ByVal Value As String)
        tbCallBack.Text = tbCallBack.Text & "VarChangeCallback: " & ID & "   " & Value & vbCrLf
    End Sub

    Public Sub VarUpdateCallbackImpl(ByVal ID As Integer, ByVal Time As Double, ByVal Value As String)
        tbCallBack.Text = tbCallBack.Text & "VarUpdateCallback: " & ID & "   " & Value & vbCrLf
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.CheckForIllegalCrossThreadCalls = False
    End Sub
End Class
